<script setup lang="ts">
import { computed, reactive, watch } from "vue";
import type {
  API_File,
  API_Object_Types,
  API_Object_Type,
  API_Attribute_Types,
  API_Attribute_Type,
} from "@/types";
import { api_call, number_or_string_to_int } from "@/functions";

const CFLOW_COL_NAME = "control-flow";

interface Props {
  ocel_file: API_File | null;
}
const props = defineProps<Props>();

const emit = defineEmits<{
  (e: "newresult", filename: string, id: string): void;
}>();

const state = reactive<{
  object_type: {
    values: API_Object_Types;
    loading: boolean;
    selected: string | null;
    instance_count: number;
  };
  mode: {
    values: Array<string>;
    selected: string;
  };
  attributes: {
    values: API_Attribute_Types;
    loading: boolean;
    weights: Record<string, number>;
  };
  max_cluster_count: {
    min_value: number;
    max_value: number;
    selected: number;
  };
  cluster_count: {
    min_value: number;
    max_value: number;
    selected: number;
  };
  cluster_algorithm: {
    values: Array<string>;
    selected: string;
  };
  cluster_count_limit: number;
  cluster_count_val_arr: Array<number>;
  clustering_loading: boolean;
  object_properties_loading: boolean;
}>({
  object_type: {
    values: Array<API_Object_Type>(0),
    loading: false,
    selected: null,
    instance_count: 0,
  },
  mode: {
    values: ["existence", "all"],
    selected: "all",
  },
  attributes: {
    values: Array<API_Attribute_Type>(0),
    loading: false,
    weights: {},
  },
  cluster_count: {
    min_value: 2,
    max_value: 2,
    selected: -1,
  },
  max_cluster_count: {
    min_value: 2,
    max_value: 2,
    selected: -1,
  },
  cluster_algorithm: {
    values: Array<string>("kmeans", "agglomerative", "spectral"),
    selected: "kmeans",
  },
  cluster_count_limit: 2,
  cluster_count_val_arr: Array<number>(2),
  clustering_loading: false,
  object_properties_loading: false,
});

if (props.ocel_file != null) load_object_types(); // Init

async function load_object_types() {
  if (props.ocel_file != null) {
    state.object_type.loading = true;
    const response = await api_call(
      "/ocel-cluster/" + props.ocel_file.id + "/object-types",
      "GET"
    );
    state.object_type.values = (await response.json()).data;
    if (state.object_type.values.length > 0)
      state.object_type.selected = state.object_type.values[0].id; // Auto setting to first valu
    state.object_type.loading = false;
  }
}

async function load_attributes(object_type: string) {
  if (object_type != null && props.ocel_file != null) {
    state.attributes.loading = true;
    const response = await api_call(
      "/ocel-cluster/" +
        props.ocel_file.id +
        "/object-types/" +
        object_type +
        "/attributes",
      "GET"
    );
    state.attributes.values = (await response.json()).data;
    const weights: Record<string, number> = {};
    for (const index in state.attributes.values) {
      weights[state.attributes.values[index].id] = 1.0;
    }
    weights[CFLOW_COL_NAME] = 1.0;
    state.attributes.weights = weights;
    state.attributes.loading = false;
  }
}

async function load_instance_count(object_type: string) {
  if (object_type != null && props.ocel_file != null) {
    state.object_properties_loading = true;
    const response = await api_call(
      "/ocel-cluster/" +
        props.ocel_file.id +
        "/object-types/" +
        object_type +
        "/instance-count",
      "GET"
    );

    state.object_type.instance_count = (
      await response.json()
    ).data.attributes.count;

    await Promise.all([
      refresh_max_cluster_limit(),
      refresh_cluster_count_val_arr(),
    ]);
    let tmp_max_cluster_count = Math.floor(
      Math.log2(state.object_type.instance_count)
    );
    if (tmp_max_cluster_count < 2) tmp_max_cluster_count = 2;
    state.max_cluster_count.selected = tmp_max_cluster_count;
    state.object_properties_loading = false;
  }
}

function create_clustering_param_body(): JSON {
  const res = {
    data: {
      "object-type": state.object_type.selected,
      mode: state.mode.selected,
      "max-cluster-count": state.max_cluster_count.selected,
      "cluster-count": state.cluster_count.selected,
      "attr-weights": state.attributes.weights,
      "cluster-algorithm": state.cluster_algorithm.selected,
    },
  };
  return JSON.parse(JSON.stringify(res)); // stupid but working
}

async function apply_clustering() {
  if (props.ocel_file != null && state.object_type.selected != null) {
    state.clustering_loading = true;
    const response = await api_call(
      "/ocel-cluster/" + props.ocel_file?.id,
      "POST",
      create_clustering_param_body()
    );
    const new_clustering_res_id = (await response.json()).data.id;
    state.clustering_loading = false;
    emit("newresult", props.ocel_file.id, new_clustering_res_id);
  }
}

function refresh_max_cluster_limit() {
  let res = state.object_type.instance_count - 1;
  if (res < 2) res = 2;
  state.cluster_count_limit = res;
}

function refresh_cluster_count_val_arr() {
  const len = state.cluster_count_limit - 1; // n-1 possible
  const res = [...Array(len).keys()].map((i) => i + 2);
  state.cluster_count_val_arr = res;
}

const c_cluster_count = computed({
  get() {
    return state.cluster_count.selected;
  },
  set(val: number | string) {
    state.cluster_count.selected = number_or_string_to_int(val);
  },
});

const c_max_cluster_count = computed({
  get() {
    return state.max_cluster_count.selected;
  },
  set(val: number | string) {
    state.max_cluster_count.selected = number_or_string_to_int(val);
  },
});

const c_properties_ready = computed(() => {
  return !state.attributes.loading && !state.object_properties_loading;
});

watch(
  () => props.ocel_file,
  () => {
    load_object_types();
  }
);

watch(
  () => state.object_type.selected,
  (val) => {
    if (val != null) {
      load_attributes(val);
      load_instance_count(val);
    }
  }
);
</script>

<template>
  <div class="row border-bottom mb-3 pb-3">
    <h4 class="text-light">Algorithm parameters</h4>
    <div class="col-12 col-md-6 mb-2">
      <div class="form-floating">
        <select
          class="form-select"
          id="object-type-selector"
          aria-label="object-type-selection"
          :disabled="state.object_type.loading"
          v-model="state.object_type.selected"
        >
          <option
            v-for="object_type of state.object_type.values"
            :key="object_type.id"
            :value="object_type.id"
          >
            {{ object_type.id }}
          </option>
        </select>
        <label for="object-type-selector">Object Type</label>
      </div>
      <p v-if="!state.object_type.loading" class="mb-0 text-light">
        <template v-if="state.object_properties_loading">
          <p class="fst-italic">
            Loading details for object-type
            <span class="fw-bold">{{ state.object_type.selected }}</span
            >...
          </p>
        </template>
        <template v-else>
          <span class="fw-bold">{{ state.object_type.instance_count }}</span>
          instances of object-type
          <span class="fw-bold">{{ state.object_type.selected }}</span> found.
        </template>
      </p>
    </div>

    <template v-if="state.object_type.loading">
      <div class="col-12 text-light">Object types loading...</div>
    </template>

    <template v-if="!state.object_type.loading">
      <div class="col-12 col-md-6 mb-2">
        <div class="form-floating">
          <select
            class="form-select"
            id="mode-selector"
            aria-label="mode-selection"
            v-model="state.mode.selected"
          >
            <option v-for="mode of state.mode.values" :key="mode" :value="mode">
              {{ mode }}
            </option>
          </select>
          <label for="mode-selector">Mode</label>
        </div>
      </div>

      <div class="col-12 mb-2">
        <h6 class="text-light">
          Attribute definition (only non-nan attributes)
        </h6>
        <div class="row g-1">
          <div
            class="col-12 col-sm-6 col-md-3 col-lg-2"
            v-for="attribute in state.attributes.values"
            :key="attribute.id"
          >
            <div class="form-floating">
              <input
                type="number"
                class="form-control"
                :id="'input-' + attribute.id"
                v-model="state.attributes.weights[attribute.id]"
                :disabled="state.attributes.loading"
              />
              <label for="floatingInput">{{ attribute.id }}</label>
            </div>
          </div>

          <div class="col-12 col-sm-6 col-md-3 col-lg-2">
            <div class="form-floating">
              <input
                type="number"
                class="form-control"
                :id="'input-' + CFLOW_COL_NAME"
                v-model="state.attributes.weights[CFLOW_COL_NAME]"
                :disabled="state.attributes.loading"
              />
              <label for="floatingInput">{{ CFLOW_COL_NAME }}</label>
            </div>
          </div>
        </div>
      </div>

      <h6 class="text-light">Other optional parameters</h6>

      <div class="col-12 col-md-6 mb-2">
        <div class="form-floating">
          <select
            class="form-select"
            id="cluster-count-selector"
            aria-label="cluster-count-selection"
            v-model="c_cluster_count"
            :disabled="state.object_properties_loading"
          >
            <option value="-1">auto</option>
            <option
              v-for="num in state.cluster_count_val_arr"
              :key="num"
              :value="num"
            >
              {{ num }}
            </option>
          </select>
          <label for="cluster-count-selector">cluster-count</label>
        </div>
      </div>
      <div class="col-12 col-md-6 mb-2">
        <div class="form-floating">
          <select
            class="form-select"
            id="max-cluster-count-selector"
            aria-label="max-cluster-count-selection"
            v-model="c_max_cluster_count"
            :disabled="state.object_properties_loading"
          >
            <option value="-1">auto</option>
            <option
              v-for="num in state.cluster_count_val_arr"
              :key="num"
              :value="num"
            >
              {{ num }}
            </option>
          </select>
          <label for="max-cluster-count-selector">max-cluster-count</label>
        </div>
        <p class="text-light">
          <span class="text-uppercase fw-bold">Attention: </span>This parameter
          drastically affects the runtime. The suggested value is
          ⌊log₂(instance_count)⌋. If you are using auto on a large
          instance_count you may encouter timeouts or other runtime problems.
        </p>
      </div>
      <div class="col-12 d-grid">
        <button
          @click="apply_clustering"
          class="btn btn-primary btn-block"
          :disabled="state.clustering_loading || !c_properties_ready"
        >
          <template v-if="!state.clustering_loading"
            >Apply Clustering algorithm
          </template>
          <template v-else>
            <span
              class="spinner-border spinner-border-sm"
              role="status"
              aria-hidden="true"
            ></span>
          </template>
        </button>
      </div>
    </template>
  </div>
</template>
